/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:26:13 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * A guideCategory resource identifies a category that YouTube algorithmically assigns based on a
 * channel's content or other indicators, such as the channel's popularity. The list is similar to
 * video categories, with the difference being that a video's uploader can assign a video category
 * but only YouTube can assign a channel category.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GuideCategory extends com.google.api.client.json.GenericJson {

  /**
   * Etag of this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The ID that YouTube uses to uniquely identify the guide category.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind, fixed to "youtube#guideCategory".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The snippet object contains basic details about the category, such as its title.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GuideCategorySnippet snippet;

  /**
   * Etag of this resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * Etag of this resource.
   * @param etag etag or {@code null} for none
   */
  public GuideCategory setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The ID that YouTube uses to uniquely identify the guide category.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The ID that YouTube uses to uniquely identify the guide category.
   * @param id id or {@code null} for none
   */
  public GuideCategory setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind, fixed to "youtube#guideCategory".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind, fixed to "youtube#guideCategory".
   * @param kind kind or {@code null} for none
   */
  public GuideCategory setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The snippet object contains basic details about the category, such as its title.
   * @return value or {@code null} for none
   */
  public GuideCategorySnippet getSnippet() {
    return snippet;
  }

  /**
   * The snippet object contains basic details about the category, such as its title.
   * @param snippet snippet or {@code null} for none
   */
  public GuideCategory setSnippet(GuideCategorySnippet snippet) {
    this.snippet = snippet;
    return this;
  }

  @Override
  public GuideCategory set(String fieldName, Object value) {
    return (GuideCategory) super.set(fieldName, value);
  }

  @Override
  public GuideCategory clone() {
    return (GuideCategory) super.clone();
  }

}
